import _classCallCheck from "F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/createClass";
import _inherits from "F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/inherits";
import _createSuper from "F:/vue-create-web/node_modules/@babel/runtime/helpers/esm/createSuper";
import { __decorate } from "tslib";
import * as echarts from 'echarts';
import { Component, Vue, Prop } from 'vue-property-decorator';
var resizeCache = {};

var resizeFn = function resizeFn() {
  for (var key in resizeCache) {
    if (Object.prototype.hasOwnProperty.call(resizeCache, key)) {
      var element = resizeCache[key];
      element.updateWidth();
    }
  }

  setTimeout(resizeFn, 500);
};

var BaseCharts = /*#__PURE__*/function (_Vue) {
  _inherits(BaseCharts, _Vue);

  var _super = _createSuper(BaseCharts);

  function BaseCharts() {
    var _this;

    _classCallCheck(this, BaseCharts);

    _this = _super.apply(this, arguments);
    _this.resize_ele_width = 0;
    _this.resize_ele_height = 0;
    return _this;
  }

  _createClass(BaseCharts, [{
    key: "mounted",
    value: function mounted() {
      resizeCache[this._uid] = this;
      this.resize_ele_width = this.$el.clientWidth;
      this.resize_ele_height = this.$el.clientHeight;
      this.initChart();
    }
  }, {
    key: "destory",
    value: function destory() {
      delete resizeCache[this._uid];
    }
  }, {
    key: "initChart",
    value: function initChart() {
      if (this.$refs.chart) {
        this.chart = echarts.init(this.$refs.chart);
        this.chart.setOption(this.options);
        this.chart.on('click', this.chartOnClick);
      }
    }
  }, {
    key: "updateWidth",
    value: function updateWidth() {
      this.resize_ele_width = this.$el.clientWidth;
      this.resize_ele_height = this.$el.clientHeight;
    }
  }, {
    key: "onResize",
    value: function onResize() {
      if (this.chart) this.chart.resize();
    }
  }, {
    key: "chartOnClick",
    value: function chartOnClick() {}
  }, {
    key: "render",
    value: function render(CreateElement) {
      return CreateElement('div', {
        ref: 'chart',
        style: {
          width: '100%',
          height: '100%'
        }
      });
    }
  }, {
    key: "options",
    get: function get() {
      return {};
    }
  }]);

  return BaseCharts;
}(Vue);

__decorate([Prop()], BaseCharts.prototype, "chartData", void 0);

BaseCharts = __decorate([Component({
  watch: {
    options: function options() {
      if (this.chart) this.chart.setOption(this.options);
    },
    chartData: function chartData() {
      if (this.chart) this.chart.setOption(this.options);
    },
    resize_ele_width: function resize_ele_width() {
      if (this.onResize) this.onResize();
    },
    resize_ele_height: function resize_ele_height() {
      if (this.onResize) this.onResize();
    }
  }
})], BaseCharts);
export default BaseCharts;
resizeFn();